from setuptools import setup


def readme():
    with open('README.md', encoding='utf-8') as f:
        content = f.read()
    return content


setup(
    # 包名称
    name='DataAcquisition',

    # 版本
    version='1.0.0',

    # 作者
    author='LiuZe',

    # 作者邮箱
    author_email='lz2297519360@outlook.com',

    # 长文描述
    long_description=readme(),

    # 长文描述的文本格式
    long_description_content_type='text/markdown',

    # 关键词
    keywords='DataAcquisition',

    # 包的分类信息，见https://pypi.org/pypi?%3Aaction=list_classifiers
    classifiers=[
    ],
    # 许可证
    license='Apache License 2.0',

    # python版本要求
    python_requires='>=3.7',

    # 表明当前模块依赖哪些包，若环境中没有，则会从pypi中自动下载安装！！！
    install_requires=[
        # vzense tof3d-sdk need
        "numpy",
        "opencv-python",     # 如果无法自动安装，可以尝试在终端调用 pip install opencv-python 进行安装
        # zx sdk
        'glog',
        'aio-pika >= 9.0.0',
        'protobuf == 4.23.4',
        # 工具
        'pyqt5',
        'PyQt5-tools'
    ],

    # setup.py 本身要依赖的包，这通常是为一些setuptools的插件准备的配置，这里列出的包，不会自动安装。
    setup_requires=[],

    # 仅在测试时需要使用的依赖，在正常发布的代码中是没有用的。
    # 在执行python setup.py test时，可以自动安装这三个库，确保测试的正常运行。
    tests_require=[
    ],

    # install_requires 在安装模块时会自动安装依赖包
    # 而 extras_require 不会，这里仅表示该模块会依赖这些包
    # 但是这些包通常不会使用到，只有当你深度使用模块时，才会用到，这里需要你手动安装
    extras_require={
    }

)
